﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Web
Imports System.Web.Mvc
Imports System.Web.Routing
Imports MvcControllers.Infrastructure
Imports StructureMap
Imports MvcControllers.Controllers
Imports System.Web.Security

Namespace MvcControllers
	' Note: For instructions on enabling IIS6 or IIS7 classic mode, 
	' visit http://go.microsoft.com/?LinkId=9394801

	Public Class MvcApplication
		Inherits System.Web.HttpApplication
		Public Shared Sub RegisterRoutes(ByVal routes As RouteCollection)
			routes.IgnoreRoute("{resource}.axd/{*pathInfo}")

			routes.MapRoute("SayHello", "Hello", New With {Key .controller = "Hello", Key .action="SayHello", Key .id=99})

			routes.MapRoute("Default", "{controller}/{action}/{id}", New With {Key .controller = "Home", Key .action = "Index", Key .id = ""})

		End Sub

		Protected Sub Application_Start()
			RegisterRoutes(RouteTable.Routes)
			ControllerBuilder.Current.SetControllerFactory(New MyControllerFactory())
			ConfigureContainer()
		End Sub

		Private Sub ConfigureContainer()
			StructureMapConfiguration.ForRequestedType(Of ILogger)().TheDefaultIsConcreteType(Of SqlServerLogger)()
			StructureMapConfiguration.ForRequestedType(Of IFormsAuthentication)().TheDefaultIsConcreteType(Of FormsAuthenticationService)()
			StructureMapConfiguration.ForRequestedType(Of IMembershipService)().TheDefaultIsConcreteType(Of AccountMembershipService)()
            StructureMapConfiguration.ForRequestedType(Of MembershipProvider)().AddInstance(Membership.Provider)
		End Sub
	End Class
End Namespace