﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Web
Imports System.Web.Mvc
Imports System.Diagnostics
Imports System.Web.Routing

Namespace MvcControllers.Infrastructure
	Public Class LogAttribute
		Inherits ActionFilterAttribute
		Public Overrides Sub OnActionExecuting(ByVal filterContext As ActionExecutingContext)
			Log("Action Executing", filterContext.RouteData)
		End Sub

		Public Overrides Sub OnActionExecuted(ByVal filterContext As ActionExecutedContext)
			Log("Action Executed", filterContext.RouteData)
		End Sub

		Public Overrides Sub OnResultExecuting(ByVal filterContext As ResultExecutingContext)
			Log("Result Executing", filterContext.RouteData)
		End Sub

		Public Overrides Sub OnResultExecuted(ByVal filterContext As ResultExecutedContext)
			Log("Result Executed", filterContext.RouteData)
		End Sub

		Private Sub Log(ByVal stageName As String, ByVal routeData As RouteData)
			Debug.WriteLine(String.Format("{0}::{1} - {2}", routeData.Values("controller"), routeData.Values("action"), stageName))
		End Sub
	End Class
End Namespace
